#include "types.h"

struct bst_node **asp(graph *g, node_id s, 
                      struct bst_node **dest_set, long nb_dest,
                      struct link **links_seen, 
                      long* nb_asp_nodes, long* nb_links);

struct bst_node** deterministic_usp(graph* g, node_id src, 
                                    struct bst_node** dest_set, long nb_dest,
                                    struct link** p_links_seen, long* nb_links_seen_part);
struct bst_node** usp(graph* g, node_id src, 
                      struct bst_node** dest_set, long nb_dest,
                      struct link** p_links_seen, long* nb_links_seen_part);


void swap_link (graph* g);
void rewire (graph *g);
void add_random_link (graph *g, long link_id);
long remove_random_link (graph *g);
struct bst_node** gen_destinations (graph* g, long nb_dest);
node_id gen_source (graph* g);

