#include "types.h"

typedef struct graph {
  node_id n;
  node_id m;
  struct bst_node** adjacencies;
  node_id *linklistleft;
  node_id *linklistright;
} graph;

graph *empty_graph(node_id n, node_id m);
graph *empty_graph_gnp (node_id n, node_id m);
void free_graph(graph *g);
void print_graph(graph *g);
void remove_link (graph *g, long link);
int add_link (graph *g, long link_id, node_id a, node_id b);
