#include <stdio.h>
#include "iterator.h"

queue *iterate_init (void* node, long size){
  queue *q;
  q = empty_queue (size);
  if (node != NULL)
    queue_add (q, (void*) node);
  return (q);
}

//FIXME: there is two versions of iterate initerate_next:
//       'iterate_next_node' and 'iterate_next_link'
//       they are located in 'nodes.c' and 'links.c'

void iterate_end(queue *q){
  free_queue(q);
}
